var _a;
import { Account, CoMap, CoValueBase, ValueRef, isControlledAccount, } from "../internal.js";
export class Profile extends CoMap {
}
Profile.encoding({ name: "json" });
export class Group extends CoValueBase {
    get _encoding() {
        return this.constructor._encoding;
    }
    get _refs() {
        const profileID = this._raw.get("profile");
        const rootID = this._raw.get("root");
        return {
            profile: profileID &&
                new ValueRef(profileID, this._loadedAs, this._encoding.profile.ref()),
            root: rootID &&
                new ValueRef(rootID, this._loadedAs, this._encoding.root.ref()),
        };
    }
    constructor(init, options) {
        super();
        let raw;
        if (options && "fromRaw" in options) {
            raw = options.fromRaw;
        }
        else {
            const initOwner = options?.owner || init?.owner;
            if (!initOwner)
                throw new Error("No owner provided");
            if (initOwner instanceof Account &&
                isControlledAccount(initOwner)) {
                const rawOwner = initOwner._raw;
                raw = rawOwner.createGroup();
            }
            else {
                throw new Error("Can only construct group as a controlled account");
            }
        }
        Object.defineProperties(this, {
            id: {
                value: raw.id,
                enumerable: false,
            },
            _raw: { value: raw, enumerable: false },
            profile: {
                get: () => {
                    const ref = this._refs.profile;
                    return ref ? ref.accessFrom(this) : undefined;
                },
                set: (value) => {
                    if (value) {
                        this._raw.set("profile", value.id);
                    }
                },
            },
            root: {
                get: () => {
                    const ref = this._refs.root;
                    return ref ? ref.accessFrom(this) : undefined;
                },
                set: (value) => {
                    if (value) {
                        this._raw.set("root", value.id);
                    }
                },
            },
        });
    }
    myRole() {
        return this._raw.myRole();
    }
    addMember(member, role) {
        this._raw.addMember(member === "everyone" ? member : member._raw, role);
    }
    static define(fields) {
        this._encoding || (this._encoding = {});
        Object.assign(this._encoding, fields);
    }
}
_a = Group;
(() => {
    _a.prototype._type = "Group";
})();
(() => {
    _a._encoding = {
        profile: { json: true },
        root: { json: true },
    };
    Object.defineProperty(_a.prototype, "_encoding", {
        get: () => _a._encoding,
    });
})();
//# sourceMappingURL=group.js.map